Scriptname SLHH_MCM extends SKI_ConfigBase conditional

;OIDs

int CommentChanceOID
int StageChanceOID
int dangerousConditionOID
int resetOID
int enableOID
int AnimOID
int RelationOID
int moralOID
int threesomeOID
int NighttimeOID
int TimeoutOID
int CompanionOID

;Properties
GlobalVariable Property SLHH_Chance auto
GlobalVariable Property SLHH_relation auto
GlobalVariable Property SLHH_moral auto
GlobalVariable Property SLHH_timeout auto
GlobalVariable Property SLHH_nighttime auto
GlobalVariable Property GameHour auto
Quest Property SLHH auto
bool property enable = true auto conditional
float property CommentChance = 80.0 auto	
float property StageChance = 50.0 auto
bool property dangerousCondition = false auto conditional
bool property reset = false auto
string property anim = "Aggressive" auto
float property moral = 0.0 auto
float property relation = 4.0 auto
float property threesome = 50.0 auto
bool property nighttime = false auto
bool property companion = true auto
float property timeout = 1.0 auto

event OnConfigInit()
	Pages = new string[1]
	Pages[0] = "Settings"
endevent

event OnPageReset(string Page)

SetCursorFillMode(TOP_TO_BOTTOM)

if page == "Settings"
	AddHeaderOption("Horrible Harassment by Guffel")
	AddEmptyOption()
	enableOID = AddToggleOption("Enabled", enable)
	commentChanceOID =  addslideroption("Harassment Chance:", commentchance, "{0.0}")
	StageChanceOID =  addslideroption("Repeated Stage Chance:", stageChance, "{0.0}")
	AddHeaderOption("2nd Repetition Chance:" + stagechance * 0.67, OPTION_FLAG_DISABLED)
	AddHeaderOption("3rd Repetition Chance:" + stagechance * 0.34, OPTION_FLAG_DISABLED)
	DangerousConditionOID = AddToggleOption("Dangerous Condition:", dangerousCondition)
	animOID = AddTextOption("Animation Setting:", anim)
	AddEmptyOption()
	ResetOID = AddToggleOption("Rest Quest:", reset)
	
	SetCursorPosition(3)
	
	relationOID =  addslideroption("Relationship Rank:", relation, "{0.0}")
	moralOID =  addslideroption("Morality:", moral, "{0.0}")
	threesomeOID =  addslideroption("Threesome chance:", threesome, "{0.0}")
	companionOID = AddToggleOption("Attack Follower:", companion)
	timeoutOID =  addslideroption("Timeout:", timeout, "{0.0}")
	nighttimeOID = AddToggleOption("Only At Night:", nighttime)
	
endif
endevent

Event OnOptionSliderOpen(Int Option)
	if option == CommentChanceOID
		SetSliderDialogStartValue(CommentChance)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == StageChanceOID
		SetSliderDialogStartValue(StageChance)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == relationOID
		SetSliderDialogStartValue(relation)
		SetSliderDialogDefaultValue(4.0)
		SetSliderDialogRange(-3.0, 5.0)
		SetSliderDialogInterval(1.0)
	elseif option == moralOID
		SetSliderDialogStartValue(moral)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 3.0)
		SetSliderDialogInterval(1.0)
	elseif option == threesomeOID
		SetSliderDialogStartValue(threesome)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == timeoutOID
		SetSliderDialogStartValue(timeout)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 24.0)
		SetSliderDialogInterval(1.0)
	endif
endevent

Event OnOptionSliderAccept(Int Option, Float value)
	If Option == CommentChanceOID
		CommentChance = value
		SetSliderOptionValue(CommentChanceOID, CommentChance, "{0.0}")
		SLHH_Chance.SetValue(CommentChance)
	elseIf Option == StageChanceOID
		StageChance = value
		SetSliderOptionValue(StageChanceOID, StageChance, "{0.0}")
	elseIf Option == relationOID
		relation = value
		SetSliderOptionValue(relationOID, relation, "{0.0}")
		SLHH_relation.SetValue(relation)
	elseIf Option == MoralOID
		Moral = value
		SetSliderOptionValue(MoralOID, Moral, "{0.0}")
		SLHH_moral.SetValue(moral)
	elseIf Option == threesomeOID
		threesome = value
		SetSliderOptionValue(threesomeOID, threesome, "{0.0}")
	elseIf Option == timeoutOID
		timeout = value
		SetSliderOptionValue(timeoutOID, timeout, "{0.0}")
		SLHH_Timeout.SetValue(timeout)
	endif
endevent

event OnOptionSelect(int option)
	if (option == enableOID)
		enable = !enable
		SetToggleOptionValue(enableOID, enable)
	elseif (option == DangerousConditionOID)
		DangerousCondition = !DangerousCondition
		SetToggleOptionValue(DangerousConditionOID, DangerousCondition)
	elseif (option == resetOID)
		SetToggleOptionValue(resetOID, reset)
		SLHH.SetStage(160)
		Debug.Notification("SLHH Quest resetted!")
	elseif (option == animOID)
		if anim == "Aggressive"
			anim = "Sleeping/Necro"
		elseIf anim == "Sleeping/Necro"
			anim = "Leitos-Bound"
		else
			anim = "Aggressive"
		endif
		SetTextOptionValue(animOID, anim)
	elseif (option == nighttimeOID)
		nighttime = !nighttime
		SetToggleOptionValue(nighttimeOID, nighttime)
		if nighttime == true
			If GameHour.GetValue() >= 18 || GameHour.GetValue() < 6
				SLHH_Nighttime.SetValue(1)
			else
				SLHH_Nighttime.SetValue(0)
			endif
		else
			SLHH_Nighttime.SetValue(1)
		endif
	elseif (option == companionOID)
		companion = !companion
		SetToggleOptionValue(companionOID, companion)
	endif
endevent

event OnOptionHighlight(int option)
	if (option == moralOID)
		SetInfoText("All NPC with this or higher moralty level can approach. \n 0 = No Crime, 1 = Property Crime, 2 = Crimes Against Enemys, 3 = Any Crime")
	elseIf (option == relationOID)
		SetInfoText("All NPC with this or higher relationship rank can't approach. \n -4 = Archnemesis, -3 = Enemy, -2 = Foe, -1 = Rival, 0 = Acquaintance, 1 = Friend, 2 = Confidant, 3 = Ally, 4 = Lover")
	elseIf (option == timeoutOID)
		SetInfoText("Timeout in game-hours between harassments.")
	elseIf (option == nighttimeOID)
		SetInfoText("If toggled, the harassments are limited to happen between 6 pm to 6 am.")
	elseIf (option == companionOID)
		SetInfoText("A female follower is attacked by an close random npc.")
	endif
endevent